/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { Base, Type, String_$type, typeCast, enumGetBox, fromEnum, runOn, delegateCombine, delegateRemove, Date_$type, Point_$type, markType } from "igniteui-react-core/ES2015/type";
import { Series } from "./Series";
import { Brush } from "igniteui-react-core/ES2015/Brush";
import { Thickness } from "igniteui-react-core/ES2015/Thickness";
import { CalloutCollisionMode_$type } from "./CalloutCollisionMode";
import { FontUtil } from "igniteui-react-core/ES2015/FontUtil";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { HashSet$1 } from "igniteui-react-core/ES2015/HashSet$1";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { LinkedList$1 } from "igniteui-react-core/ES2015/LinkedList$1";
import { Dictionary$2 } from "igniteui-react-core/ES2015/Dictionary$2";
import { LinkedListNode$1 } from "igniteui-react-core/ES2015/LinkedListNode$1";
import { LabelCollisionManager } from "igniteui-react-core/ES2015/LabelCollisionManager";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { CalloutAnnotation } from "./CalloutAnnotation";
import { IFastItemsSource_$type } from "igniteui-react-core/ES2015/IFastItemsSource";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { QuadTreeBoundingBox } from "igniteui-react-core/ES2015/QuadTreeBoundingBox";
import { LabelCollisionInfo } from "igniteui-react-core/ES2015/LabelCollisionInfo";
import { ScalerParams } from "./ScalerParams";
import { Size } from "igniteui-react-core/ES2015/Size";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutKey } from "./CalloutKey";
import { DataContext } from "igniteui-react-core/ES2015/DataContext";
import { HashPool$2 } from "igniteui-react-core/ES2015/HashPool$2";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
import { isNaN_ } from "igniteui-react-core/ES2015/number";
import { stringIsNullOrEmpty } from "igniteui-react-core/ES2015/string";
import { FastItemObjectColumn } from "igniteui-react-core/ES2015/FastItemObjectColumn";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-react-core/ES2015/BrushUtil";
import { TextBlock } from "igniteui-react-core/ES2015/TextBlock";
import { DOMExecutionContext } from "igniteui-react-core/ES2015/DOMExecutionContext";
import { Color } from "igniteui-react-core/ES2015/Color";
import { Line } from "igniteui-react-core/ES2015/Line";
import { CalloutViewHelper } from "./CalloutViewHelper";
import { Rectangle } from "igniteui-react-core/ES2015/Rectangle";
import { TranslateTransform } from "igniteui-react-core/ES2015/TranslateTransform";
/**
 * @hidden
 */
export class CalloutLayer extends AnnotationLayer {
    constructor() {
        super();
        this.calloutStyleUpdating = null;
        this.m6 = null;
        this.m7 = null;
        this.m8 = null;
        this.m5 = null;
        this.m4 = null;
        this.nu = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        this.nx = new List$1(CalloutAnnotationWrapper.$, 0);
        this.ny = new List$1(CalloutAnnotationWrapper.$, 0);
        this.m2 = null;
        this.nv = new LinkedList$1(CalloutAnnotationWrapper.$);
        this.ns = new Dictionary$2(CalloutAnnotationWrapper.$, LinkedListNode$1.$.specialize(CalloutAnnotationWrapper.$), 0);
        this.ne = null;
        this.qn = new Rect(0, 0, 0, 1, 1);
        this.nk = false;
        this.n8 = 0;
        this.qm = Rect.empty;
        this.nj = false;
        this.calloutContentUpdating = null;
        this.calloutLabelUpdating = null;
        this.calloutSeriesSelecting = null;
        this.nw = new List$1(SeriesPointOfInterest.$, 0);
        this.nm = false;
        this.nn = false;
        this.n0 = 0;
        this.nl = false;
        this.ni = true;
        FastItemObjectColumn.k();
        this.l1 = true;
        let a = new CalloutLayerFrame();
        let b = new CalloutLayerFrame();
        let c = new CalloutLayerFrame();
        let d = this.ff / 1000;
        this.lv = a;
        this.lu = b;
        this.lw = c;
        this.ab = CalloutLayer.$;
    }
    pf(a, b) {
        this.ny.clear();
        this.i6(false);
    }
    hs(a, b, c, d) {
        super.hs(a, b, c, d);
        let e = this.nt();
        switch (a) {
            case 3:
                this.pr(b, e);
                break;
            case 1:
                for (let f = b; f < b + c; f++) {
                    let g = new CalloutAnnotation();
                    let h = new CalloutAnnotationWrapper();
                    h.b = g;
                    h.b.series = this.m1;
                    this.ny.insert(f, h);
                    this.pr(f, e);
                }
                break;
            case 0:
                this.ny.v(b, c);
                break;
            case 2:
                for (let i = b; i < b + c; i++) {
                    this.pr(i, e);
                }
                break;
            case 4:
                this.ny.clear();
                for (let j = 0; j < this.bz.count; j++) {
                    let k = new CalloutAnnotation();
                    let l = new CalloutAnnotationWrapper();
                    l.b = k;
                    l.b.series = this.m1;
                    this.ny.add(l);
                    this.pr(j, e);
                }
                break;
        }
        this.i6(true);
    }
    c9(a) {
        return false;
    }
    nt() {
        let a = new Dictionary$2(String_$type, Series.$, 0);
        if (this.bs != null) {
            for (let b = 0; b < this.bs.series.count; b++) {
                let c = this.bs.series._inner[b];
                if (c.name != null && !a.containsKey(c.name)) {
                    a.addItem(c.name, c);
                }
            }
        }
        return a;
    }
    pr(a, b) {
        if (this.nd == null || this.nb == null) {
            return;
        }
        let c = a;
        if (this.nc != null) {
            c = this.nc.item(a);
        }
        let d = this.nd.item(a);
        let e = this.nb.item(a);
        let f = this.ny._inner[a];
        f.b.xValue = c;
        f.b.yValue = d;
        f.b.text = e != null ? e.toString() : "";
        if (this.na != null) {
            f.b.key = this.na.item(a);
        }
        if (this.m9 != null) {
            f.b.content = this.m9.item(a);
        }
        else {
            f.b.content = this.bz.item(a);
        }
        if (this.calloutSeriesSelecting != null) {
            let g = ((() => {
                let $ret = new CalloutSeriesSelectingEventArgs();
                $ret.c = c;
                $ret.d = d;
                $ret.item = this.bz.item(a);
                return $ret;
            })());
            this.calloutSeriesSelecting(this, g);
            if (g.a != null) {
                f.b.series = g.a;
            }
            else if (g.e != null) {
                if (b.containsKey(g.e)) {
                    f.b.series = b.item(g.e);
                }
            }
        }
        this.ps(f);
    }
    ps(a) {
        let b = new Thickness(0, 3);
        if (isNaN_(this.qp.c) || isNaN_(this.qp.e) || isNaN_(this.qp.d) || isNaN_(this.qp.b)) {
            b = new Thickness(0, 3);
        }
        else {
            b = this.qp;
        }
        let c = this.qi != null ? this.qi : this.my.ce(a.b.series);
        let d = this.ql != null ? this.ql : this.my.ch();
        let e = this.qk != null ? this.qk : this.my.cg();
        let f = this.qj != null ? this.qj : this.my.cf(a.b.series);
        let g = isNaN_(this.n6) ? 0 : this.n6;
        if (this.nq && this.calloutStyleUpdating != null) {
            let h = new CalloutStyleUpdatingEventArgs();
            h.item = a.b.content;
            h.xValue = a.b.xValue;
            h.yValue = a.b.yValue;
            h.series = a.b.series;
            h.background = c;
            h.textColor = d;
            h.outline = e;
            h.leaderBrush = f;
            h.strokeThickness = g;
            this.calloutStyleUpdating(this, h);
            c = h.background;
            d = h.textColor;
            e = h.outline;
            f = h.leaderBrush;
            g = h.strokeThickness;
        }
        a.b.backgroundPadding = b;
        a.b.background = c;
        a.b.textColor = d;
        a.b.outline = e;
        a.b.leaderBrush = f;
        a.b.strokeThickness = g;
    }
    get nb() {
        return this.m6;
    }
    set nb(a) {
        if (this.m6 != a) {
            let b = this.m6;
            this.m6 = a;
            this.raisePropertyChanged("LabelColumn", b, this.m6);
        }
    }
    get nc() {
        return this.m7;
    }
    set nc(a) {
        if (this.m7 != a) {
            let b = this.m7;
            this.m7 = a;
            this.raisePropertyChanged("XColumn", b, this.m7);
        }
    }
    get nd() {
        return this.m8;
    }
    set nd(a) {
        if (this.m8 != a) {
            let b = this.m8;
            this.m8 = a;
            this.raisePropertyChanged("YColumn", b, this.m8);
        }
    }
    get na() {
        return this.m5;
    }
    set na(a) {
        if (this.m5 != a) {
            let b = this.m5;
            this.m5 = a;
            this.raisePropertyChanged("KeyColumn", b, this.m5);
        }
    }
    get m9() {
        return this.m4;
    }
    set m9(a) {
        if (this.m4 != a) {
            let b = this.m4;
            this.m4 = a;
            this.raisePropertyChanged("ContentColumn", b, this.m4);
        }
    }
    ph(a, b) {
        if (b.propertyName == CalloutAnnotation.$$p[13] || b.propertyName == CalloutAnnotation.$$p[14]) {
            let c = a.k;
            if (!this.nu.contains(c)) {
                this.nx.add(c);
                this.i6(false);
            }
        }
    }
    bf() {
        return new CalloutLayerView(this);
    }
    im(a) {
        super.im(a);
        this.my = a;
    }
    get qp() {
        return new Thickness(1, this.n2, this.n4, this.n3, this.n1);
    }
    get m3() {
        if (this.m2 == null) {
            this.m2 = FontUtil.toFontInfo(this.e1, this.o6);
        }
        return this.m2;
    }
    mc(a, b) {
        if (this.m1 == null || this.m1 == a) {
            if (!this.aq.c) {
                this.i6(b);
            }
        }
    }
    me(a, b) {
        super.me(a, b);
        let c = a;
        c.p.clear();
        c.q.clear();
        c.m.clear();
        c.f.clear();
        c.h.clear();
        c.g.clear();
        c.j.clear();
        c.l.clear();
        c.k.clear();
        c.i.clear();
        c.n.clear();
        c.o.clear();
        c.t.clear();
        c.u.clear();
        c.r.clear();
        c.s.clear();
        let d = this.nz();
        let e = new List$1(CalloutAnnotationWrapper.$, 0);
        if (this.no) {
            if (this.lz(this.m1)) {
                this.po(this.m1, c, e);
            }
            else {
                for (let f of fromEnum(this.bs.series)) {
                    if (this.lz(f)) {
                        this.po(f, c, e);
                    }
                }
            }
        }
        this.pn(c, d, e);
    }
    jm(a, b) {
        super.jm(a, b);
        let c = b.width - this.qn.width;
        let d = b.height - this.qn.height;
        let e = 0;
        if (Math.abs(c) > Math.abs(d)) {
            e = c;
            this.n0 = c * this.lr.width;
        }
        else {
            e = d;
            this.n0 = d * this.lr.height;
        }
        if (e > 0 && this.n0 > 5) {
            this.nn = true;
        }
        if (e < 0 && this.n0 > 5) {
            this.nm = true;
        }
    }
    jl(a, b) {
        super.jl(a, b);
        if (!a.equals1(b)) {
            this.nl = true;
        }
    }
    get qo() {
        return this.qm;
    }
    set qo(a) {
        this.qm = a;
    }
    pn(a, b, c) {
        if (this.bs != null) {
            this.qn = this.bs.mq;
        }
        if (this.lr.isEmpty) {
            return;
        }
        this.qo = new Rect(0, this.lr.left, this.lr.top, this.lr.width, this.lr.height);
        if (this.ne != null && this.or != null && this.or != this.ne.ak) {
            this.pj();
        }
        if (this.ne == null) {
            let d = this.nf();
            if (d != null) {
                this.ne = d;
                let e = this.ne;
                e.labelsMoved = delegateCombine(e.labelsMoved, runOn(this, this.pg));
            }
            else {
                let f = this.lj(this.bi);
                this.ne = new LabelCollisionManager(this.lr.right, this.lr.bottom, this.lr, this.my.b4(), this.n5, this.ng(), this.oc(), this.ob(), this.np);
                if (this.or != null) {
                    this.ne.ak = this.or;
                    this.ne.ai = this;
                }
                let g = this.ne;
                g.labelsMoved = delegateCombine(g.labelsMoved, runOn(this, this.pg));
            }
        }
        if (this.nm) {
            this.nm = false;
            if (this.ne.ag > 2) {
                this.nk = true;
            }
        }
        if (this.nn) {
            this.nn = false;
            if (this.n0 > 5) {
                this.nk = true;
            }
        }
        if (this.nl) {
            this.nl = false;
            this.ne.ax(this.lr.right, this.lr.bottom, this.lr);
            this.nk = true;
        }
        let h = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        let i = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        let j = new List$1(CalloutAnnotationWrapper.$, 0);
        let k = new List$1(CalloutAnnotationWrapper.$, 0);
        let l = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (let m = 0; m < b.count; m++) {
            l.add_1(b._inner[m]);
        }
        for (let n = 0; n < c.count; n++) {
            l.add_1(c._inner[n]);
        }
        let o = this.nv.c;
        while (o != null) {
            let p = o.a;
            if (!l.contains(o.c)) {
                k.add(o.c);
                i.add_1(o.c);
                let q = o.c.b;
                q.propertyChanged = delegateRemove(q.propertyChanged, runOn(this, this.ph));
                this.nv.h(o);
                this.ns.removeItem(o.c);
                this.ne.aw(o.c.c);
            }
            o = p;
        }
        for (let r = 0; r < b.count; r++) {
            if (!this.ns.containsKey(b._inner[r])) {
                this.nv.f(b._inner[r]);
                let s = b._inner[r].b;
                s.propertyChanged = delegateCombine(s.propertyChanged, runOn(this, this.ph));
                this.ns.addItem(b._inner[r], this.nv.d);
                j.add(b._inner[r]);
                h.add_1(b._inner[r]);
                this.nk = true;
            }
        }
        for (let t = 0; t < c.count; t++) {
            if (!this.ns.containsKey(c._inner[t])) {
                this.nv.f(c._inner[t]);
                this.ns.addItem(c._inner[t], this.nv.d);
                let u = c._inner[t].b;
                u.propertyChanged = delegateCombine(u.propertyChanged, runOn(this, this.ph));
                j.add(c._inner[t]);
                h.add_1(c._inner[t]);
                this.nk = true;
            }
        }
        if (this.nx.count > 0) {
            this.nk = true;
            this.nx.clear();
            this.nu.clear();
        }
        o = this.nv.c;
        while (o != null) {
            let v = this.nh(o.c);
            if (v == null) {
                return;
            }
            if (!Base.equalsStatic(v, o.c.c.c)) {
                let w = false;
                if (o.c.c.c == null) {
                    w = true;
                }
                let x = o.c.c;
                x.o = v.b;
                x.p = v.c;
                if (!isNaN_(x.o) && !isNaN_(x.p)) {
                    x.n = v.e;
                    x.m = v.d;
                    if (x.b == null) {
                        this.ne.p(x);
                    }
                    if (w) {
                        this.ne.al(x);
                    }
                    else {
                        this.ne.at(x);
                    }
                }
            }
            o = o.a;
        }
        let y = this.ne.ah();
        let z = this.ne.q();
        if (this.nk && (y != 0 || z)) {
            this.nk = false;
            this.n8 = 0x7FFFFFFF;
            if (this.or != null) {
                let aa = true;
                for (let ab = 0; ab < this.bs.series.count; ab++) {
                    let ac = this.bs.series._inner[ab];
                    if (ac.cj && typeCast(CalloutLayer.$, ac) !== null) {
                        let ad = ac;
                        if (ad.or == this.or) {
                            if (!ad.qo.equals1(this.ne.az)) {
                                aa = false;
                                break;
                            }
                        }
                    }
                }
                if (aa) {
                    this.ne.ay();
                }
                else {
                    this.ne.am();
                }
            }
            else {
                this.ne.ay();
            }
        }
        let ae = this.nv.c;
        while (ae != null) {
            let af = ae.c;
            a.m.add1(af);
            a.f.add(af.b.background);
            a.h.add(af.b.outline);
            a.g.add(af.b.leaderBrush);
            a.j.add(af.b.backgroundPadding.c);
            a.l.add(af.b.backgroundPadding.e);
            a.k.add(af.b.backgroundPadding.d);
            a.i.add(af.b.backgroundPadding.b);
            a.n.add(af.b.strokeThickness);
            a.o.add(af.b.textColor);
            a.p.add1(af.b.text);
            a.q.add1(af.b.content);
            let ag = af.c;
            a.t.add(af.c.o - (af.c.g - af.c.l));
            a.u.add(af.c.p - (af.c.h - af.c.k));
            a.r.add(af.c.g - af.c.l);
            a.s.add(af.c.h - af.c.k);
            ae = ae.a;
        }
    }
    pj() {
        if (this.ne != null) {
            let a = this.nv.c;
            while (a != null) {
                let b = a.c.c;
                if (b != null) {
                    this.ne.aw(b);
                }
                a = a.a;
            }
            let c = this.ne;
            c.labelsMoved = delegateRemove(c.labelsMoved, runOn(this, this.pg));
            this.ne = null;
        }
        this.pi();
    }
    nf() {
        if (this.bs == null) {
            return null;
        }
        for (let a = 0; a < this.bs.series.count; a++) {
            let b = this.bs.series._inner[a];
            if (b.cj && typeCast(CalloutLayer.$, b) !== null) {
                let c = b;
                if (c != this) {
                    if (c.or != null && c.or == this.or) {
                        if (c.ne != null) {
                            return c.ne;
                        }
                    }
                }
            }
        }
        return null;
    }
    ob() {
        return 20000;
    }
    oc() {
        return 300;
    }
    ng() {
        switch (this.mv) {
            case 0: return 2;
            case 2: return 1;
            case 3: return 2;
            case 1: return 0;
        }
        return 2;
    }
    pg(a) {
        let b = this.ne.ah();
        if (b < this.n8) {
            this.n8 = b;
            this.i6(false);
        }
    }
    nh(a) {
        let b = this.m1;
        if (a.b.series != null) {
            b = a.b.series;
        }
        if (b == null) {
            for (let c = 0; c < this.bs.series.count; c++) {
                let d = this.bs.series._inner[c];
                if (!d.cj) {
                    b = d;
                    break;
                }
            }
        }
        if (b == null) {
            return null;
        }
        let e = b.ag();
        let f = b.ee();
        let g = null;
        let h = null;
        for (let i = 0; i < e.length; i++) {
            if (e[i].ce) {
                h = e[i];
            }
            else {
                g = e[i];
            }
        }
        if (g == null || h == null) {
            return null;
        }
        if (!g.cd() || !h.cd()) {
            return null;
        }
        let j = 0;
        if (g.b2 && g.categoryMode != 0) {
            if (b.cr) {
                j = b.getOffsetValue();
            }
            else if (b.cl) {
                j = b.getOffsetValue();
            }
        }
        let k = new ScalerParams(0, this.bs.mq, g.iu, g.b8, g.ip());
        k.b = f;
        let l = new ScalerParams(0, this.bs.mq, h.iu, h.b8, h.ip());
        l.b = f;
        let m = g.dt(this.n7(a.b.xValue), k) + j;
        let n = h.dt(this.n7(a.b.yValue), l);
        let o = new QuadTreeBoundingBox();
        o.b = m;
        o.c = n;
        o.e = 3;
        o.d = 3;
        o.g = a.b;
        return o;
    }
    n7(a) {
        if (typeCast(Date_$type, a) !== null) {
            return a.getTime();
        }
        if (a == null) {
            return 0;
        }
        return a;
    }
    nz() {
        let a = new List$1(CalloutAnnotationWrapper.$, 0);
        for (let b = 0; b < this.ny.count; b++) {
            if (stringIsNullOrEmpty(this.ny._inner[b].b.text)) {
                continue;
            }
            if (this.ny._inner[b].c == null) {
                let c = new LabelCollisionInfo();
                this.ny._inner[b].c = c;
                let d = this.my.cj(this.od(this.ny._inner[b]), this.ny._inner[b].b.backgroundPadding);
                c.k = d.height / 2;
                c.l = d.width / 2;
            }
            let e = this.nh(this.ny._inner[b]);
            if (e == null || e.b < this.lr.left || e.b > this.lr.right || e.c < this.lr.top || e.c > this.lr.bottom) {
                continue;
            }
            a.add(this.ny._inner[b]);
        }
        return a;
    }
    od(a) {
        return a.b.text;
    }
    lz(a) {
        if (!super.lz(a)) {
            return false;
        }
        return true;
    }
    ig() {
        super.ig();
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ni) {
            this.ni = false;
            this.pl();
        }
        if (this.ca()) {
            this.pq(this.lw, false);
        }
        else {
            this.pq(this.lu, false);
        }
    }
    pm() {
        if (!this.nj) {
            this.nj = true;
            this.i6(true);
        }
    }
    po(a, b, c) {
        if (a.ch(this.nw, this.nr, this.n9)) {
            let d = this.nw;
            for (let e = 0; e < this.nw.count; e++) {
                let f = d._inner[e];
                let g = f.a.item != null ? f.a.item : f.a;
                let h = a;
                let i = new CalloutKey(g, h);
                let j = new CalloutAnnotationWrapper();
                let k = new CalloutAnnotation();
                j.b = k;
                k.key = i;
                let l = false;
                let m = false;
                if (this.nj) {
                    this.nj = false;
                    m = true;
                }
                if (this.ns.containsKey(j)) {
                    j = this.ns.item(j).c;
                    k = j.b;
                }
                else {
                    if (!m) {
                        l = true;
                    }
                }
                let n = k.xValue;
                let o = k.yValue;
                if (this.n7(n) != this.n7(f.b)) {
                    k.xValue = f.b;
                }
                if (this.n7(o) != this.n7(f.c)) {
                    k.yValue = f.c;
                }
                k.series = a;
                if (l && this.calloutLabelUpdating != null) {
                    let p = ((() => {
                        let $ret = new CalloutLabelUpdatingEventArgs();
                        $ret.c = k.xValue;
                        $ret.d = k.yValue;
                        $ret.item = g;
                        return $ret;
                    })());
                    this.calloutLabelUpdating(this, p);
                    if (p.b != null && !Base.equalsStatic(p.b, j.b.text)) {
                        let q = p.b;
                        j.b.text = q != null ? q.toString() : "";
                    }
                }
                else {
                    if (f.d != null) {
                        k.text = f.d;
                    }
                }
                if (k.text == null) {
                    continue;
                }
                if (l) {
                    if (this.calloutContentUpdating != null) {
                        let r = ((() => {
                            let $ret = new CalloutContentUpdatingEventArgs();
                            $ret.c = k.xValue;
                            $ret.d = k.yValue;
                            $ret.item = g;
                            $ret.a = g;
                            return $ret;
                        })());
                        this.calloutContentUpdating(this, r);
                        if (r.a != null && r.a != j.b.content) {
                            j.b.content = r.a;
                        }
                    }
                    else {
                        if (g != null && g != j.b.content) {
                            j.b.content = g;
                        }
                    }
                }
                if (l) {
                    this.ps(j);
                }
                if (j.c == null) {
                    let s = new LabelCollisionInfo();
                    j.c = s;
                    let t = this.my.cj(this.od(j), j.b.backgroundPadding);
                    s.k = t.height / 2;
                    s.l = t.width / 2;
                }
                let u = this.nh(j);
                if (u == null || u.b < this.lr.left || u.b > this.lr.right || u.c < this.lr.top || u.c > this.lr.bottom) {
                    continue;
                }
                c.add(j);
            }
        }
    }
    bd() {
        return 1;
    }
    ar(a, b) {
        let c = this.ne.d(a, b);
        if (c == null) {
            return null;
        }
        return c.u;
    }
    dg(a, b) {
        if (this.ne == null) {
            return false;
        }
        return this.ne.d(a, b) != null;
    }
    pq(a, b) {
        let c = 0;
        let d = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (c = 0; c < a.p.count; c++) {
            let e = a.m._inner[c];
            if (isNaN_(a.t._inner[c]) || isNaN_(a.u._inner[c])) {
                continue;
            }
            let f = this.my.b6.item(e);
            d.add_1(e);
            if (f.f != a.p._inner[c]) {
                f.f = a.p._inner[c];
                let g = f.s();
            }
            f.c = a.n._inner[c];
            f.k = a.f._inner[c];
            f.n = a.o._inner[c];
            f.m = f.c > 0 ? a.h._inner[c] : this.bi.bn();
            f.l = a.g._inner[c];
            f.v = new Thickness(1, a.j._inner[c], a.l._inner[c], a.k._inner[c], a.i._inner[c]);
            this.my.cc(f, Math.min(a.r._inner[c], a.r._inner[c] + a.t._inner[c]), Math.min(a.s._inner[c], a.s._inner[c] + a.u._inner[c]));
            this.my.cd(f, e, a.q._inner[c]);
            f.p = { $type: Point_$type, x: a.t._inner[c], y: a.u._inner[c] };
        }
        let h = new List$1(CalloutAnnotationWrapper.$, 0);
        for (let i of fromEnum(this.my.b6.c)) {
            if (!d.contains(i)) {
                h.add(i);
            }
        }
        for (let j = 0; j < h.count; j++) {
            this.my.b6.g(h._inner[j]);
        }
    }
    mh(a, b) {
        super.mh(a, b);
        if (this.ca()) {
            this.pq(this.lw, true);
        }
        else {
            this.pq(this.lu, false);
        }
    }
    c7() {
        return true;
    }
    is(a, b, c, d) {
        super.is(a, b, c, d);
        switch (b) {
            case CalloutLayer.$$p[21]:
                this.m2 = null;
                this.i6(true);
                break;
            case CalloutLayer.$$p[20]:
                this.i6(true);
                break;
            case CalloutLayer.$$p[13]:
                this.i6(true);
                break;
            case "SeriesViewer":
                if (c != null) {
                    let e = c;
                    e.seriesAnimating = delegateRemove(e.seriesAnimating, runOn(this, this.pp));
                }
                if (d != null) {
                    let f = d;
                    f.seriesAnimating = delegateCombine(f.seriesAnimating, runOn(this, this.pp));
                }
                if (d == null) {
                    this.pj();
                }
                break;
            case CalloutLayer.$$p[15]:
            case CalloutLayer.$$p[16]:
            case CalloutLayer.$$p[1]:
            case CalloutLayer.$$p[5]:
            case CalloutLayer.$$p[4]:
            case CalloutLayer.$$p[7]:
            case CalloutLayer.$$p[9]:
            case CalloutLayer.$$p[8]:
            case CalloutLayer.$$p[6]:
            case CalloutLayer.$$p[11]:
            case CalloutLayer.$$p[12]:
                this.pk();
                break;
            case CalloutLayer.$$p[19]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nb);
                    this.nb = this.by(this.o3);
                }
                break;
            case "LabelColumn":
                this.pk();
                break;
            case CalloutLayer.$$p[14]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.m9);
                    this.m9 = this.by(this.ou);
                }
                break;
            case "ContentColumn":
                this.pk();
                break;
            case CalloutLayer.$$p[23]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nc);
                    this.nc = stringIsNullOrEmpty(this.pa) == false ? this.by(this.pa) : null;
                }
                break;
            case "XColumn":
                this.pk();
                break;
            case CalloutLayer.$$p[24]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nd);
                    this.nd = this.by(this.pd);
                }
                break;
            case "YColumn":
                this.pk();
                break;
            case CalloutLayer.$$p[18]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.na);
                    this.na = this.by(this.o0);
                }
                break;
            case "KeyColumn":
                this.pk();
                break;
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nb);
                    c.deregisterColumn(this.m9);
                    c.deregisterColumn(this.nc);
                    c.deregisterColumn(this.nd);
                    c.deregisterColumn(this.na);
                    this.nb = null;
                    this.m9 = null;
                    this.nc = null;
                    this.nd = null;
                    this.na = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nb = this.by(this.o3);
                    this.m9 = this.by(this.ou);
                    if (stringIsNullOrEmpty(this.pa) == false) {
                        this.nc = this.by(this.pa);
                    }
                    this.nd = this.by(this.pd);
                    this.na = this.by(this.o0);
                }
                this.pk();
                break;
        }
    }
    pp(a) {
        if (a.cj) {
            return;
        }
        if ((a == this.m1 || this.m1 == null) && this.no) {
            this.i6(false);
        }
    }
    pk() {
        if (this.ni == false) {
            this.ni = true;
            this.i6(false);
        }
    }
    pi() {
        this.my.b6.clear();
        this.nv.g();
        this.ns.clear();
    }
    pl() {
        if (this.nd == null || this.nb == null) {
            let a = this.nv.c;
            while (a != null) {
                this.ps(a.c);
                a = a.a;
            }
            return;
        }
        let b = this.nt();
        for (let c = 0; c < this.nd.count; c++) {
            let d;
            if (this.ny.count <= c) {
                let e = new CalloutAnnotation();
                d = new CalloutAnnotationWrapper();
                d.b = e;
                d.b.series = this.m1;
                this.ny.add(d);
            }
            else {
                d = this.ny._inner[c];
            }
            this.pr(c, b);
        }
    }
}
CalloutLayer.$t = markType(CalloutLayer, 'CalloutLayer', AnnotationLayer.$);
Type.dep(DependencyProperty, PropertyMetadata, CalloutLayer, 'raisePropertyChanged', ['AutoCalloutLabelPrecision:n9:pt', [1, 5], 'CalloutBackground:qi:pu', [Brush.$, null], 'CalloutCollisionMode:mv:pv', [CalloutCollisionMode_$type, enumGetBox(CalloutCollisionMode_$type, 3)], 'CalloutInterpolatedValuePrecision:oa:pw', [1, -1], 'CalloutLeaderBrush:qj:px', [Brush.$, null], 'CalloutOutline:qk:py', [Brush.$, null], 'CalloutPaddingBottom:n1:pz', [1, NaN], 'CalloutPaddingLeft:n2:p0', [1, NaN], 'CalloutPaddingRight:n3:p1', [1, NaN], 'CalloutPaddingTop:n4:p2', [1, NaN], 'CalloutPositionPadding:n5:p3', [1, 10], 'CalloutStrokeThickness:n6:p4', [1, NaN], 'CalloutTextColor:ql:p5', [Brush.$, null], 'CollisionChannel:or:p6', [2, null], 'ContentMemberPath:ou:p7', [2, null], 'IsAutoCalloutBehaviorEnabled:no:p8', [0, false], 'IsCalloutOffsettingEnabled:np:p9', [0, true], 'IsCustomCalloutStyleEnabled:nq:qa', [0, false], 'KeyMemberPath:o0:qb', [2, null], 'LabelMemberPath:o3:qc', [2, null], 'TargetSeries:m1:qd', [Series.$, null], 'TextStyle:o6:qe', [2, null], 'UseValueForAutoCalloutLabels:nr:qf', [0, true], 'XMemberPath:pa:qg', [2, null], 'YMemberPath:pd:qh', [2, null]]);
/**
 * @hidden
 */
export class CalloutLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b7 = null;
        this.b6 = null;
        this.b8 = NaN;
        this.b2 = null;
        this.b1 = a;
        this.b7 = new List$1(CalloutView.$, 0);
    }
    ap() {
        super.ap();
        this.b6 = ((() => {
            let $ret = new HashPool$2(CalloutAnnotationWrapper.$, CalloutView.$);
            $ret.create = runOn(this, this.b3);
            $ret.activate = runOn(this, this.b9);
            $ret.disactivate = runOn(this, this.cb);
            $ret.destroy = runOn(this, this.ca);
            return $ret;
        })());
    }
    b3() {
        let a = new CalloutView(this);
        this.b7.add(a);
        return a;
    }
    b9(a) {
        a.w = 0;
    }
    cb(a) {
        a.w = 1;
    }
    ca(a) {
        this.b7.remove(a);
    }
    ci(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.h(a, 0.1);
    }
    a3(a, b) {
        super.a3(a, b);
        a.ac(this.b5());
        if (a.d && !b) {
            for (let c = 0; c < this.b7.count; c++) {
                let d = this.b7._inner[c];
                if (d.w == 0) {
                    d.h(a);
                }
            }
        }
    }
    b5() {
        if (this.b1.m3 != null) {
            return this.b1.m3;
        }
        return this.e.bs.getFontInfo();
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b7.count; b++) {
            let c = this.b7._inner[b];
            if (c.w != 0) {
                continue;
            }
            c.g(this.b1, this.b5(), a);
        }
    }
    ck(a) {
        if (isNaN_(this.b8)) {
            this.b8 = this.e.bs.bn.a7;
        }
        return new Size(1, this.h.f(a.ak), this.b8);
    }
    cj(a, b) {
        if (this.b2 == null) {
            this.b2 = new CalloutView(this);
        }
        this.b2.f = a;
        this.b2.v = b;
        let c = this.b2.s();
        this.b2.f = null;
        return c;
    }
    b4() {
        return new DOMExecutionContext(this.e.bs.bn.i.af);
    }
    cc(a, b, c) {
        a.d = b;
        a.e = c;
    }
    cd(a, b, c) {
        a.i(this.e, b, c);
    }
    ce(a) {
        if (a != null) {
            return this.ci(a.kw);
        }
        return this.e.kw;
    }
    ch() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    }
    cg() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    }
    cf(a) {
        if (a != null) {
            return this.ci(a.kw);
        }
        return this.e.kw;
    }
}
CalloutLayerView.$t = markType(CalloutLayerView, 'CalloutLayerView', AnnotationLayerView.$);
/**
 * @hidden
 */
export class CalloutView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.w = 0;
        this.j = null;
        this.r = null;
        this.o = { $type: Point_$type, x: 0, y: 0 };
        this.q = null;
        this.u = new Thickness(0, 0);
        this.t = null;
        this.d = 0;
        this.e = 0;
        this.b = null;
        this.q = new Line();
        this.q.ab = false;
        this.q._stroke = ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 0, 0, 0);
            return $ret;
        })());
        this.q.ac = 2;
        this.j = new TextBlock();
        this.r = new Rectangle();
        this.r.ac = 0;
        this.a = a;
        this.w = 0;
    }
    h(a) {
        a.z();
        a.af(this.d, this.e);
        let b = new TranslateTransform();
        b.j = this.t.c;
        b.k = this.t.e;
        this.r.j = b;
        a.r(this.q);
        a.z();
        this.r.width = this.j.m + this.u.c + this.u.d;
        this.r.height = this.j.l + this.u.e + this.u.b;
        a.j(this.r.j);
        a.v(this.r);
        this.j.o = this.u.e;
        this.j.n = this.u.c;
        a.w(this.j);
        a.y();
        a.y();
    }
    get p() {
        return this.o;
    }
    set p(a) {
        if (this.o.x != a.x || this.o.y != a.y) {
            let b = this.s();
            let c = b.height;
            let d = b.width;
            this.o = a;
            let e = CalloutViewHelper.b(this.p, d, c, this.q);
            this.t = e;
        }
    }
    get n() {
        return this.j.am;
    }
    set n(a) {
        this.j.am = a;
    }
    get m() {
        return this.r._stroke;
    }
    set m(a) {
        this.r._stroke = a;
    }
    get l() {
        return this.q._stroke;
    }
    set l(a) {
        this.q._stroke = a;
    }
    get k() {
        return this.r._fill;
    }
    set k(a) {
        this.r._fill = a;
    }
    get c() {
        return this.r.ac;
    }
    set c(a) {
        this.r.ac = a;
    }
    get v() {
        return this.u;
    }
    set v(a) {
        this.u = a;
    }
    get f() {
        return this.j.ak;
    }
    set f(a) {
        if (a == null) {
            this.j.ak = "";
        }
        else {
            this.j.ak = a.toString();
        }
        let b = this.s();
        let c = b.height;
        let d = b.width;
        let e = CalloutViewHelper.b(this.p, d, c, this.q);
        this.t = e;
    }
    s() {
        let a = this.a.ck(this.j);
        this.j.m = a.width;
        this.j.l = a.height;
        return new Size(1, a.width + this.u.c + this.u.d, a.height + this.u.e + this.u.b);
    }
    i(a, b, c) {
        if (this.b == null) {
            this.b = new DataContext();
        }
        this.b.series = a;
        this.b.item = c;
        if (b.c != null) {
            b.c.u = this.b;
        }
    }
    g(a, b, c) {
        a.a2.exportCalloutData(this.d, this.e, this.t.c, this.t.e, c, this.r, this.j, b, this.q, "callout", ["Main", "Callout"]);
    }
}
CalloutView.$t = markType(CalloutView, 'CalloutView');
